Lua_BulletinBoardSecWindow = class("Lua_BulletinBoardSecWindow", Lua_Window)
function Lua_BulletinBoardSecWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.TIPS_WINDOW_LAYER;
    self.windowName = "Lua_BulletinBoardSecWindow";
    self.isFullSizeWin = true;
    self.openSound = nil;
    self.closeSound = nil;

    self.showWidth = 521;
	self.showArr = Array();
end

function Lua_BulletinBoardSecWindow:buildShowItem()
	self:superCall("buildShowItem");

    MsgUtil.callFunc("FPS_UPDATE", 60);
    self.bgSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_zjm_widget_01", 0, -95, self.showWidth, 47);
    self.bgSp.anchorValue = 1;

    self.mask = UICreate.createUIMaskContainer(self.content, nil, nil, 0, -95, self.showWidth, 47);
    self.mask.anchorValue = 1;
    self.mask:setColor(1, 1, 1, 1);
    self.mask:addRectMask2D();

    self.txt = UICreate.createLabel(self.mask.sub, nil, 0, 0, self.showWidth, 47, 22);
    self.txt.anchorValue = 1;
    self.txt.pivotValue = 4;
    self.txt.alignmentValue = 4;
    self.txt.horizontalOverflowValue = 1;
    self.txt.clickScale = false;
    -- self.txt:addUrlClickFuntion(self, self.onTextClick);
end

function Lua_BulletinBoardSecWindow:dispose()
    self:stopTimer();
    if self.mask ~= nil then
        self.mask:dispose();
        self.mask = nil;
    end
    if self.showArr ~= nil then
        self.showArr:dispose();
        self.showArr:clear();
        self.showArr = nil;
    end
    self.data = nil;
    MsgUtil.callFunc("FPS_UPDATE");
    self:superCall("dispose");
end

function Lua_BulletinBoardSecWindow:showWin(param)
	self:superCall("showWin", param);
    for i = 1, param.playNum do
        self.showArr:add(param);
    end
    self.showArr:sort("priority", true);
    
    local len = self.showArr:getSize();
    local maxLen = Lua_CommonUtil.getCommonConfig("broadcast_limit", 1, 10);
    while len > maxLen do
        local vo = self.showArr:shift();
        DataCenter.chatData:returnBroadcastVo(vo);
        len = len - 1;
    end

	if self.bTimer ~= true then
		self:updateData();
	end
end

function Lua_BulletinBoardSecWindow:updateData()
    if self.data ~= nil then
        DataCenter.chatData:returnBroadcastVo(self.data);
        self.data = nil;
    end

    if self.showArr:getSize() > 0 then
        self.data = self.showArr:shift();

        self.txt.text = self.data.content;
        self.txt.alpha = 1;
        self.curTime = getTime();
        self.playTime = self.data.showSec;
        self.txt:setLocation(0, 0, 0);

        if self.data.playType == 2 then
            local txtLen = self.txt:GetFontlen(self.txt.text);
            self.startX = self.showWidth / 2 + txtLen / 2;
            self.txt:setLocation(self.startX, 0, 0);
        else
            self.hideTime = self.playTime * 0.3;
            self.tempStep = 1 / (self.hideTime / 0.02);
            self.temp = self.tempStep;
        end
    	self:startTimer();
    else
        self:hide();
    end
end

function Lua_BulletinBoardSecWindow:startTimer()
    if self.bTimer ~= true then
        self.bTimer = true;
        Lua_CommonUtil.addTimer("Lua_BulletinBoardSecWindow", 0.02, self, self.onTimer, nil, -1, true);
    end
end

function Lua_BulletinBoardSecWindow:stopTimer()
    if self.bTimer == true then
        self.bTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onTimer, true);
    end
end

function Lua_BulletinBoardSecWindow:onTimer()
    if self.data.playType == 2 then
        local tempTime = getTime() - self.curTime
        if tempTime >= self.playTime then
            self:updateData();
        else
            local fromx = self.txt.posX;
            local pos_x = self.startX - self.startX * 2 * (tempTime / self.playTime);
            self.txt:setLocation(fromx + (pos_x - fromx) * 0.1, 0, 0);
        end
    else
        local num = getTime();
        self.playTime = self.playTime - (num - self.curTime);
        self.curTime = num;
        if self.playTime <= 0 then
            self:updateData();
        elseif self.playTime <= self.hideTime then
            self.txt.alpha = 1 - self.temp;
            self.temp = self.temp + self.tempStep;
        end
    end
end

-- function Lua_BulletinBoardSecWindow:onTextClick(urlStr)
--     if self.data == nil then
--         return;
--     end
--     Lua_ChatUtil.urlClickHandle(urlStr, self.data);
-- end