-- 聊天表情
Lua_ChatEmojiWindow = class("Lua_ChatEmojiWindow", Lua_Window);
function Lua_ChatEmojiWindow:ctor()
    self:superCall("ctor");
    self.blackAlpha = 0.1;
    self.isClickClose = true;
    self.showBlackMask = true;
    self.windowName = "Lua_ChatEmojiWindow";
    self.skinName = "ChatEmojiWindow_skin";
end

function Lua_ChatEmojiWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.emojiTab = {};
	self.btnInfo = Array();
	self.btnInfo:add({emjioType = 1,  name = LanUtil.getValue(171045)});
	self.btnInfo:add({emjioType = 2,  name = LanUtil.getValue(171046)});

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.buttonList:setLocation(159, -121, 0);
    self.buttonList:setButtonCell(Lua_ChatEmojiBtnItem);
    self.buttonList:setButtonItem(126, 55);
    self.buttonList:setClickCallBack(self, self.onButtonClick);
    self.buttonList:setData(self.btnInfo);
    self.buttonList:setSelected(1);

    self:addLuaEvent("CHAT_DYNAMIC_EMOJI_SELECT", self, self.sendDynamicEmoji);-- 动态表情
end

function Lua_ChatEmojiWindow:showWin(param)
    self:superCall("showWin",param);
    LuaUtil.setObjPos(self.content, param.pos[1], param.pos[2], 0);
end

function Lua_ChatEmojiWindow:onButtonClick(index, data)
	if self.emojiList then
		self.emojiList:setEnable(false)
	end
	local arr = DataCenter.chatData:getEmjioListByType(index);
	self.emojiList = self.emojiTab[index]
	if self.emojiList == nil then
		self.emojiList = Lua_DragList.new(self.content, 540, 214, Lua_AxisDefine.Vertical)
		if index == 1 then
			self.emojiList:setListCell(Lua_StaticEmojiItem, 45, 45, 10);
			self.emojiList:setCellSpacing(10, 10);
		else
			
			self.emojiList:setListCell(Lua_DynamicEmojiItem, 105, 108, 5);
			self.emojiList:setCellSpacing(10, 10);
			self.emojiList:setContentRect(560, 214);
		end
		self.emojiList:setLocation(0, 28, 0);

		self.emojiTab[index] = self.emojiList
	end
	self.emojiList:setEnable(true)
	self.emojiList:setArrayData(arr)
end

function Lua_ChatEmojiWindow:sendDynamicEmoji()
	self:hide();
end

function Lua_ChatEmojiWindow:dispose()
	if self.emojiTab then
		for k, v in pairs(self.emojiTab) do
			v:dispose()
			self.emojiTab[k] = nil;
		end
		self.emojiTab = nil;
	end
	self.emojiList = nil
	if self.buttonList then
		self.buttonList:dispose()
		self.buttonList = nil
	end
	if self.buttonInfo then
		self.buttonInfo:clear()
		self.buttonInfo = nil
	end
	self:superCall("dispose");
end
















-- 阵容页签
Lua_ChatEmojiBtnItem = class("Lua_ChatEmojiBtnItem", Lua_ButtonCell);
function Lua_ChatEmojiBtnItem:ctor(p)
    self:superCall("ctor", p,"ChatEmojBtnItem_skin");
end

function Lua_ChatEmojiBtnItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_ChatEmojiBtnItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end

function Lua_ChatEmojiBtnItem:setData(data)
    self.data = data;
    self.nameTxt.text = data.name;
end

function Lua_ChatEmojiBtnItem:setSelected(index)
    self.select:setEnable(index == self.index);
end

function Lua_ChatEmojiBtnItem:setCanClick(bCan)
    if bCan == true then
        self.bg.mouseEnable = true
        self.bg:addClickFuntion(self, self.onPressClick)
    else
        self.bg.mouseEnable = false
        self.bg:removeClickFuntion(self, self.onPressClick)
    end
end



















Lua_StaticEmojiItem = class("Lua_StaticEmojiItem", Lua_ListCell)
function Lua_StaticEmojiItem:buildShowItem()
	self:superCall("buildShowItem")
	self.emojiSp = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 45, 45)
end

function Lua_StaticEmojiItem:dispose()
	if self.emojiSp then
		self.emojiSp:dispose()
		self.emojiSp = nil
	end
	self:superCall("dispose")
end

function Lua_StaticEmojiItem:setData(data)
	self.data = data;
	local emojiInfo = DataCenter.chatData:getConfigById(data);
	self.emojiSp:setAltas(emojiInfo.atlas, emojiInfo.sprite);
end

function Lua_StaticEmojiItem:onPressClick()
	Lua_MsgUtil.callFunc("CHAT_STATIC_EMOJI_SELECT", self.data)
end




















Lua_DynamicEmojiItem = class("Lua_DynamicEmojiItem", Lua_ListCell)
function Lua_DynamicEmojiItem:buildShowItem()
	self:superCall("buildShowItem")
	self.emjioEff = UICreate.createUIEffect(self.content, nil, nil, 0, -54);
	self.emjioEff:setScale(0.9,0.9,0.9);
end

function Lua_DynamicEmojiItem:dispose()
	if self.emjioEff ~= nil then
		self.emjioEff:dispose();
		self.emjioEff = nil;
	end
	self:superCall("dispose")
end

function Lua_DynamicEmojiItem:setData(data)
	self.data = data

	local emojiInfo = DataCenter.chatData:getConfigById(data)
	self.emjioEff:setUrl(emojiInfo.url, emojiInfo.matName)
end

function Lua_DynamicEmojiItem:onPressClick()
	Lua_MsgUtil.callFunc("CHAT_DYNAMIC_EMOJI_SELECT", self.data)
end

