
Lua_ChatFacePanel = class("Lua_ChatFacePanel", Lua_DisplayObject);
function Lua_ChatFacePanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_ChatFacePanel:buildShowItem()
    self:superCall("buildShowItem");

    self.faceList = Lua_DragList.new(self.content, 565,170, Lua_AxisDefine.Vertical);
    self.faceList:setListCell(Lua_FaceItem, 55, 55, 10);
    --self.btnList:setCellSpacing(20,17);
    self.faceList:setLocation(-26, -300, 0);

    local list=Array();
    for i = 1, Lua_ChatUtil.MAX_FACE_INDEX do
        local str = tostring(i);
        if string.len(str) == 1 then
            str = "00"..str;
        elseif string.len(str) == 2 then
            str = "0"..str;
        end
        list:add(str);
    end
    self.faceList:setArrayData(list);
end

function Lua_ChatFacePanel:dispose()
    if self.faceList ~= nil then
        self.faceList:dispose();
        self.faceList = nil;
    end
    self:superCall("dispose");
end










Lua_FaceItem = class("Lua_FaceItem", Lua_ListCell);
function Lua_FaceItem:buildShowItem()
    self:superCall("buildShowItem");
    self.face = UICreate.createUIAtlasImage(self.content, "emoji_altas", "Chat_icon_001", 0, 0, 45, 45);
end

function Lua_FaceItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end

function Lua_FaceItem:setData(data)
    if data == nil then
        return;
    end

    self.data=data;
    self.face.name = data;
    self.face:setAltas("emoji_altas", "Chat_icon_"..data)
end

function Lua_FaceItem:onPressClick()
    if self.data == nil then
        return;
    end
    Lua_MsgUtil.callFunc("CHAT_ADD_FACE", self.data);
end