
Lua_ChatToolPanel = class("Lua_ChatToolPanel", Lua_DisplayObject);
function Lua_ChatToolPanel:ctor(p)
    self:superCall("ctor", p);

end

function Lua_ChatToolPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.toolList = Lua_DragList.new(self.content, 565,170, Lua_AxisDefine.Vertical);
    self.toolList:setListCell(Lua_ToolItem, 95, 95, 6);
    --self.btnList:setCellSpacing(20,17);
    self.toolList:setLocation(-26, -300, 0);

    local arr = DataCenter.packData:getAllPackData();
    self.toolList:setArrayData(arr);
end

function Lua_ChatToolPanel:dispose()
    if self.toolList ~= nil then
        self.toolList:dispose();
        self.toolList = nil;
    end
    self:superCall("dispose");
end









Lua_ToolItem = class("Lua_ToolItem", Lua_ListCell);
function Lua_ToolItem:buildShowItem()
    self:superCall("buildShowItem");

    self.tool = Lua_ItemIcon.new(self.content);
    self.tool:setLocation(0, 0, 0);
    self.tool:setCanClick(false);
    self.tool:setScale(0.8,0.8,0.8);
end

function Lua_ToolItem:dispose()
    if self.tool ~= nil then
        self.tool:dispose();
        self.tool = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_ToolItem:setData(data)
    self.data = DataCenter.packData:getItemVoByUnId(data)
    self.tool:setData(data);

    --self.tool.data=data;
end

function Lua_ToolItem:onPressClick()
    if self.data == nil then
        return;
    end
    DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_XUANYAO, self.data);
    Lua_MsgUtil.callFunc("CHAT_SHOW_TYPE_UPDATE");
end
