Lua_PlayerReportWindow = class("Lua_PlayerReportWindow", Lua_Window);
function Lua_PlayerReportWindow:ctor()
    self:superCall("ctor");
    self.blackAlpha = 0.01;
    self.showBlackMask = true;
    self.windowName = "Lua_PlayerReportWindow";
    self.skinName = "PlayerReportWindow_skin";
end

function Lua_PlayerReportWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.newIndox = 0;
    self.recordList = Array();

    self.msgInput.alignmentValue = 0;
    self.msgInput.colorStr = Lua_ColorDefine.transColorStr("846651");
    self.msgInput:setDefaultLangValue(171008)
    self.msgInput.text = "";
    self.msgInput.characterLimit = 100;
    self.msgInput.lineTypeValue = 1;

    self.dragContainer = Lua_DragContainer.new(self.content, 555, 200, Lua_AxisDefine.Vertical);
    self.dragContainer:setLocation(-30, -250, 0);

    self.checkBoxList = Array();
    --self.boxStateDic = {};
    for i = 1, 6 do
        local checkBox = UICreate.createCheckBox(self.content, "<color=#846651>"..LanUtil.getValue(171008+i).."</color>", 0, 0, 100, 24);
        checkBox.txt.fontName = Lua_MyUISettings.huakangFontName;
        checkBox.txt.pivot = Lua_WindowUtil.getPivot(3);
        checkBox.txt.verticalOverflowValue = 1;
        checkBox.txt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
        checkBox:setStyle(2);
        if i <= 3 then
            checkBox:setLocation(-262+(i-1)*206, 256, 0);
        else
            checkBox:setLocation(-262+(i-4)*206, 192, 0);
        end
        checkBox:addBoxChange(self,self.onBoxChange);
        self.checkBoxList:add(checkBox);
        -- self.boxStateDic[i] = checkBox.selected;
    end
    self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

    self:addLuaEvent("CHATCHECKBOX_CHANGE", self, self.setChatRecordList);
end

function Lua_PlayerReportWindow:showWin(param)
    if type(param) == "table" then
        self.data = param;
        self:setWinData();
    end
end

function Lua_PlayerReportWindow:setWinData()
    self.nameStr.text = "<color=#846651>"..LanUtil.getValue(171015).."</color><color=#f63b3b>"..self.data.name.."</color>";
    local chatList = DataCenter.chatData:getSingleMsgList(self.data.id);
    local len = chatList:getSize();
    for i = 1, len do
        self.dragContainer:addSubContainer(Lua_ChatRecordItem,chatList[i], false);
    end
    self.dragContainer:updateChildPos();
    if len <= 0 then
        self:showUI();
    end
end

function Lua_PlayerReportWindow:setChatRecordList(dic)
    if dic.state == true then
        self.recordList:add(dic.str);
    else
        self.recordList:removeItem(dic.str);
    end
end

--无发言内容
function Lua_PlayerReportWindow:showUI()
    self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_widget_012", 0, -259, 0, 0);
    self.showBg:setScale(0.8,0.8,0.8);

    self.tipsTxt = UICreate.createLabel(self.content, LanUtil.getValue(171047), 0, -285, 200, 45, 32);
    self.tipsTxt.pivot = UIUtils.Pivot.Center;
    self.tipsTxt.fontName = "huakang_font";
    self.tipsTxt.colorStr = Lua_ColorDefine.transColorStr("938680");
end

function Lua_PlayerReportWindow:onBoxChange(val)
    -- local oldIndex=0;
    -- for i = 1, #self.boxStateDic do
    --     if self.boxStateDic[i] == true then
    --         oldIndex=i;
    --     end
    -- end
    for i = 1, self.checkBoxList:getSize() do
        if self.checkBoxList[i].selected == true and i ~= self.oldIndex then
            self.newIndox = i;
            if self.oldIndex == nil then 
                self.oldIndex = i;
            end
        end
    end
    -- if oldIndex ~= 0 and self.newIndox ~= 0 then
    --     self.boxStateDic[oldIndex]=false;
    --     self.boxStateDic[self.newIndox]=true;
    --     self.checkBoxList[oldIndex].selected=false;
    -- elseif oldIndex==0 and self.newIndox ~= 0 then
    --     self.boxStateDic[self.newIndox]=true;
    -- else
    --     self.boxStateDic[oldIndex]=false;
    -- end

    if self.oldIndex ~= self.newIndox then
        self.checkBoxList[self.oldIndex].selected = false;
        self.oldIndex = self.newIndox;
    end
end

function Lua_PlayerReportWindow:onSureBtnClick(go)
    local msgText = self.msgInput.text;
    local contentIsNotNull = msgText == "" or msgText == LanUtil.getValue(171006);
    if (not contentIsNotNull) and Lua_CommonUtil.checkIsInvalid(msgText) then
        return;
    end

    if self.newIndox == 0 then
        OperateAlert.showLangValue(171016);
        return;
    end
    if self.recordList:getSize() == 0 and contentIsNotNull then
        OperateAlert.showLangValue(171017);
        return;
    end
    local msg = ProtoPublic_pb.Proto10105007();
    msg.player_id = self.data.id;
    msg.reason_type = self.newIndox;
    msg.addition = msgText;
    for i = 1, self.recordList:getSize() do
        msg.evidence:append(self.recordList[i]);
    end
    sendMsg(10105007,msg);
    Lua_WindowUtil.openWin("Lua_PlayerReportWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_PlayerReportWindow:dispose()
    if self.recordList ~= nil then
        self.recordList:dispose();
        self.recordList:clear();
        self.recordList = nil;
    end

    if self.dragContainer ~= nil then
        self.dragContainer:dispose();
        self.dragContainer = nil;
    end

    if self.checkBoxList ~= nil then
        self.checkBoxList:dispose();
        self.checkBoxList:clear();
        self.checkBoxList = nil;
    end

    self.data = nil;
    self:superCall("dispose");
end



















Lua_ChatRecordItem = class("Lua_ChatRecordItem",Lua_DragContainerItem)

function Lua_ChatRecordItem:ctor(p)
    self:superCall("ctor",p);
end

function Lua_ChatRecordItem:buildShowItem()
    self:superCall("buildShowItem");

    self.chatBox = UICreate.createCheckBox(self.content, "", 0, 0, 100, 20);
    self.chatBox.txt.pivot = Lua_WindowUtil.getPivot(3);
    self.chatBox.txt.verticalOverflowValue = 1;
    self.chatBox.txt.mouseEnable = false;
    self.chatBox:SetDimensions(550,55);
    self.chatBox:setStyle(2);
    self.chatBox:setLocation(30, 0, 0);
    self.chatBox:setScale(0.9,0.9,0.9);
    self.chatBox:addBoxChange(self,self.onCheckBoxChange);

end

function Lua_ChatRecordItem:setData(data)
    self.chatBox.txt.text = "<color=#434343>["..LanUtil.getValue(171000 + data.channel).."]</color><color=#24a912>"..data.chat_player.name..":</color>"..data.content;
end
function Lua_ChatRecordItem:onCheckBoxChange(val)
    local dic = {};
    dic.str = self.chatBox.txt.text;
    dic.state = val;
    Lua_MsgUtil.callFunc("CHATCHECKBOX_CHANGE", dic);
end

function Lua_ChatRecordItem:getHeight()
    return 55;
end

function Lua_ChatRecordItem:dispose()
    self:superCall("dispose");
end